(function($){
	var homeCaseVM = interfaceList.createVm("homeCaseVM",{
		caseLists : [],
		cityName : "上海市",
		isonline : true
	});
	window.onload=function(){
		$(".home_case_list").off("tap",'[name="homeCaseMore"]').on("tap",'[name="homeCaseMore"]',function(e){
			e.stopPropagation();
			e.preventDefault();
			var id = this.getAttribute("id");
			interfaceList.openWebview("/pages/case/case_list.html","homecaseLists",{
				extras : {
					params : {
						categoryId : id
					}
				}
			})
		});
		
		$(".homeBody").off("tap",".homeJumpWebview").on("tap",".homeJumpWebview",function(e){
			e.stopPropagation();
			e.preventDefault();
			var type = this.getAttribute("type"),
				path = "",
				targetName = "",
				isLogin = "",
				params = {},
				isWifi = true,
				_this = this;
			switch (type){
				case "checkArea":
					path="/pages/home/checkArea.html",targetName="checkArea.html",isLogin=false,params={cityName :  homeCaseVM.cityName};
					break;
				case "noticeList":
					path="/pages/home/message_list.html",targetName="message_list.html",isLogin=true;
					break;
				case "homeCaseMore":
					var categoryId = _this.getAttribute("categoryId");
					path="/pages/case/case_list.html",targetName="case_list.html",isLogin=false,params={categoryId : categoryId};
					break;
				case "homeCaseDetail":
					var id = this.getAttribute("id");
					path="/pages/case/case_detail.html",targetName="case_detail.html",isLogin=false,params={caseId :  id};
					break;
				case "cacheResource":
					path="/pages/owner/other/offline_resource.html",targetName="offline_resource.html",isLogin=true,isWifi=false;
					break;
				case "homeSearch":
					path="/pages/home/home_search.html",targetName="home_search.html",isLogin=false,isWifi=false;
					break;
				case "knowledge":
					path="/pages/supplier/supplier_list.html",targetName="supplier_list.html",isLogin=false,isWifi=false;
					break;
			};
			interfaceList.openWebview(path,targetName,{
				extras : {
					params : params
				}
			},isLogin,isWifi);
		});
		
		//服务页面跳转
		document.getElementById("serverPage").addEventListener("tap",function(e){
			e.stopPropagation();
			e.preventDefault();
			$.fire(plus.webview.getLaunchWebview(),"redirextToServer");
		},false);
	};
	
	$.plusReady(function(){
		//判断当前是否有网络
		var networkState = interfaceList.drageWifi();
		if(networkState==false){
			homeCaseVM.isonline = false;
			//从缓存中读取数据
			var caseList = plus.storage.getItem(PUSLIC_MESSAGE.cacheCase) || [];
			if(typeof caseList == "string"){
				try{
					caseList = JSON.parse(caseList);
				}catch(e){
					caseList = [];
				}
			};
			homeCaseVM.caseLists = caseList;
		}else{
			interfaceList.getAjax("/case/listGroupByCategory.htm",{},"POST",function(msg){
				homeCaseVM.caseLists = msg["data"];
				//将数据存放在session里边
				plus.storage.setItem(PUSLIC_MESSAGE.cacheCase,JSON.stringify(msg["data"]));
			});
			
			//定位当前省份
			var positions = plus.geolocation.getCurrentPosition(function(opt){
				var address = opt.address || {};
				if(typeof(address.province) == "undefined"){
					interfaceList.toast("定位失败，取默认城市上海!");
					homeCaseVM.cityName = "上海市";
				}else{
					homeCaseVM.cityName = address.province;
				}
			},function(opt){
				interfaceList.toast("定位失败，取默认城市上海!");
				homeCaseVM.cityName = "上海市";
			},{provider:'baidu'})
		}
	});
	
	//选择地区回调事件监听
	window.addEventListener("checkAreaCallback",function(e){
		var data = e.detail.cityName;
		homeCaseVM.cityName = data;
	},false);

	//网络切换事件回调
	window.addEventListener("netWorkChange",function(e){
		homeCaseVM.isonline = e.detail.wifiState;
	},false);
	
	//登录退出消息提醒事件回调
	window.addEventListener("homeMessageCallback",function(e){
		if(interfaceList.isLogin()){
			interfaceList.dragMessage();
		}else{
			var currentTarget = $(".biaozhiMessageList .unreadingMessage");
			currentTarget[0].style.display="none";				
		}
	},false);
	
	//案例浏览次数修改回调
	window.addEventListener("caseReadNumber",function(e){
		var id = e.detail.CaseId,
			agreeNumber = e.detail.agreeNumber,
			readerNumber = e.detail.readNumber;
		if(readerNumber!=null){
			$('[readerNumber="'+id+'"]')[0].innerText = readerNumber;
		};
		if(agreeNumber!=null){
			$('[agreeNumber="'+id+'"]')[0].innerText = agreeNumber;
		};
	},false);
	
	window.addEventListener("updateMessageList",function(e){
		var state = e.detail.state;
		var currentTarget = $(".biaozhiMessageList .unreadingMessage");
		if(state=="true"){
			currentTarget[0].style.display="block";				
		}else{
			currentTarget[0].style.display="none";
		};
	},false);
})(mui);
