// 获取历史消息(c2c或者group)成功回调函数
function getHistoryMsgCallback(resp) {
    $("#msg-list").append(template("msg-template",resp));
    document.querySelector(".mui-chat").scrollTop = 100000;
    //消息已读上报，以及设置会话自动已读标记
    webim.setAutoRead(resp.MsgList[0].getSession(), true, true);
    
    // 清空未读消息标记
	mui.fire(plus.webview.getLaunchWebview(),"clearUnReadMsgCount",{});
}

// 获取最新的c2c历史消息,用于重新拉取好友的聊天消息
var getLastC2CHistoryMsgs = function (cbOk, cbError) {
    var lastMsgTime = Math.round(new Date().getTime() / 1000);//默认取当前时间
    var msgKey = '';
    var options = {
        'Peer_Account': selToId, //好友帐号
        'MaxCnt': reqMsgCount, //拉取消息条数
        'LastMsgTime': lastMsgTime, //最近的消息时间，即从这个时间点向前拉取历史消息
        'MsgKey': msgKey
    };
    webim.getC2CHistoryMsgs(
            options,
            function (resp) {
                var complete = resp.Complete;//是否还有历史消息可以拉取，1-表示没有，0-表示有
                var retMsgCount = resp.MsgCount;//返回的消息条数，小于或等于请求的消息条数，小于的时候，说明没有历史消息可拉取了

                if (resp.MsgList.length == 0) {
                    webim.Log.warn("没有历史消息了:data=" + JSON.stringify(options));
                    return;
                }
                getPrePageC2CHistroyMsgInfoMap[selToId] = {//保留服务器返回的最近消息时间和消息Key,用于下次向前拉取历史消息
                    'LastMsgTime': resp.LastMsgTime,
                    'MsgKey': resp.MsgKey
                };
                if (cbOk)
                    cbOk(resp);
            },
            cbError ? cbError : function(err){
            		mui.toast(err.ErrorInfo);
            	}
            );
};

//向上翻页，获取更早的好友历史消息
var getPrePageC2CHistoryMsgs = function (cbOk, cbError) {
    var tempInfo = getPrePageC2CHistroyMsgInfoMap[selToId];//获取下一次拉取的c2c消息时间和消息Key
    var lastMsgTime;
    var msgKey;
    if (tempInfo) {
        lastMsgTime = tempInfo.LastMsgTime;
        msgKey = tempInfo.MsgKey;
    } else {
        //lastMsgTime = Math.round(new Date().getTime() / 1000);//默认取当前时间
        //msgKey = '';
        alert('获取下一次拉取的c2c消息时间和消息Key为空');
        return; 
    }
    var options = {
        'Peer_Account': selToId, //好友帐号
        'MaxCnt': reqMsgCount, //拉取消息条数
        'LastMsgTime': lastMsgTime, //最近的消息时间，即从这个时间点向前拉取历史消息
        'MsgKey': msgKey
    };
    webim.getC2CHistoryMsgs(options,
        function (resp) {
            var complete = resp.Complete;//是否还有历史消息可以拉取，1-表示没有，0-表示有
            if (resp.MsgList.length == 0) {
                webim.Log.warn("没有历史消息了:data=" + JSON.stringify(options));
                return;
            }
            getPrePageC2CHistroyMsgInfoMap[selToId] = {//保留服务器返回的最近消息时间和消息Key,用于下次向前拉取历史消息
                'LastMsgTime': resp.LastMsgTime,
                'MsgKey': resp.MsgKey
            };
            if (cbOk)
                cbOk(resp);
        },
        cbError
    );
};