//发送消息(文本或者表情)
function onSendMsg() {
	var msgText = document.querySelector("#msg-text");
    if (!selToId) {
    	mui.toast("你还没有选中好友或者群组，暂不能聊天");
        msgText.value = "";
        return;
    }
    //获取消息内容
    var msgtosend = msgText.value;
    var msgLen = webim.Tool.getStrBytes(msgtosend);

    if (msgtosend.length < 1) {
        mui.toast("发送的消息不能为空!");
        msgText.value = "";
        return;
    }
    var maxLen = webim.MSG_MAX_LENGTH.C2C;
    if (msgLen > maxLen) {
        mui.toast("消息长度超出限制(最多" + Math.round(maxLen / 3) + "汉字)");
        return;
    }
    
    // 创建消息
    var msg = createMsg();
    
    var text_obj, face_obj, tmsg, emotionIndex, emotion, restMsgIndex;
    //解析文本和表情
    var expr = /\[[^[\]]{1,3}\]/mg;
    var emotions = msgtosend.match(expr);
    if (!emotions || emotions.length < 1) {
        text_obj = new webim.Msg.Elem.Text(msgtosend);
        msg.addText(text_obj);
    } else {
        for (var i = 0; i < emotions.length; i++) {
            tmsg = msgtosend.substring(0, msgtosend.indexOf(emotions[i]));
            if (tmsg) {
                text_obj = new webim.Msg.Elem.Text(tmsg);
                msg.addText(text_obj);
            }
            emotionIndex = webim.EmotionDataIndexs[emotions[i]];
            emotion = webim.Emotions[emotionIndex];
            
            if (emotion) {
                face_obj = new webim.Msg.Elem.Face(emotionIndex, emotions[i]);
                msg.addFace(face_obj);
            } else {
                text_obj = new webim.Msg.Elem.Text(emotions[i]);
                msg.addText(text_obj);
            }
            restMsgIndex = msgtosend.indexOf(emotions[i]) + emotions[i].length;
            msgtosend = msgtosend.substring(restMsgIndex);
        }
        if (msgtosend) {
            text_obj = new webim.Msg.Elem.Text(msgtosend);
            msg.addText(text_obj);
        }
    }

	// 发送消息
	sendMsg(msg);
}

/**
 * 发送语音消息
 */
function onSendSoundMsg(path){
    // 上传语音
    uploadPlugin.upload("/system/upload/uploadSound.htm",path,null,function(data){
    	var jsonObj = JSON.parse(data.responseText);
    	if(data == "error" || jsonObj.status == "error"){
    		mui.toast("上传语音失败,请稍后重试!");
    		return;
    	}

		var uuid = jsonObj.data[0].key;
    	var second = parseInt(jsonObj.data[0].second);
    	var size = parseInt(jsonObj.data[0].size);
    	var downUrl = jsonObj.data[0].downUrl;
    	// 创建语音消息对象
    	var soundMsg = new webim.Msg.Elem.Sound(uuid,second,size,selToId,downUrl);
    	
    	// 创建消息对象
    	var msg = createMsg();
    	msg.addSound(soundMsg);
    	
    	// 发送消息
    	sendMsg(msg);
    });
}

/**
 * 发送图片
 */
function sendPic(path){
	if(typeof(path) != "string"){
		path = path["files"].toString().split(",");
	}
	// 上传图片
    uploadPlugin.upload("/system/upload/uploadImg.htm",path,null,function(data){
    	var json = JSON.parse(data.responseText);
    	if(data == "error" || json.status == "error"){
    		mui.toast("上传图片失败,请稍后重试!");
    		return;
    	}
    	
    	var jsonArray = json.data;
    	
    	mui.each(jsonArray,function(key,value){
    		var msg = createMsg();
    		var custom_obj = new webim.Msg.Elem.Custom(value.key,"img" , JSON.stringify(value));
    		
    		msg.addCustom(custom_obj);
    		
    		// 发送消息
    		sendMsg(msg);
    	});
    });
}

/**
 * 创建消息对象
 */
function createMsg(){
	if (!selSendSession) {
      var selSendSession = new webim.Session(sessionType, selToId, defaultLoginInfo.identifierNick, "", Math.round(new Date().getTime() / 1000));
    }
	
	var isSend = true;//是否为自己发送
    var seq = -1;//消息序列，-1表示sdk自动生成，用于去重
    var random = Math.round(Math.random() * 4294967296);//消息随机数，用于去重
    var msgTime = Math.round(new Date().getTime() / 1000);//消息时间戳
    var subType = webim.C2C_MSG_SUB_TYPE.COMMON;//消息子类型
    
    var msg = new webim.Msg(selSendSession, isSend, seq, random, msgTime, defaultLoginInfo.identifier, subType, defaultLoginInfo.identifierNick);
    return msg;
}

/**
 * 发送消息
 * @param {Object} msg
 */
function sendMsg(msg){
    webim.sendMsg(msg, function (resp) {
    	// 添加一条新消息
		var data = {"msg":msg};
		
		$("#msg-list").append(template("single-msg-template",data));
        document.querySelector(".mui-chat").scrollTop = 100000;
    }, function (err) {
        mui.toast(err.ErrorInfo);
    });
    
    var type = msg.getElems()[0].getType();
    if(type == webim.MSG_ELEMENT_TYPE.TEXT){
    	// 普通消息
    	document.querySelector("#msg-text").value = "";
    }else if(type == webim.MSG_ELEMENT_TYPE.SOUND){
    	// 语音消息
    	document.querySelector("#soundEndWav").play();
    }
}
