(function($, oauthLogin){
	oauthLogin.login = function (type, callback) {
		var auths = null;
		plus.oauth.getServices(function(services){
			auths = services;
			var auth = getService(type);
			login(auth);
			setTimeout(function(){
				plus.nativeUI.closeWaiting();
			}, 800);
		}, function(e){
			plus.nativeUI.closeWaiting();
		});
		
		var _callback = function(auth) {
			callback && callback({
				openId: auth.authResult.openid,
				info: auth.userInfo,
				outLogin: function() {
					logout(auth);
				}
			});
		}
		function getService(type) {
			for (var i in auths) {
				var auth = auths[i];
				if(type == auth.id){
					return auth;
				}
			}
			return null;
		}
		function login (auth){
			if(!auth.authResult){
				auth.login(function(e){
					authUserInfo(auth);
				},function(e){
					plus.nativeUI.closeWaiting();
				});
			}else{
				$.toast("已登录");
			}
		}
		
		function authUserInfo(auth){
			auth.getUserInfo(function(e){
				_callback(auth);
			}, function(e){
				//$.toast("获取用户信息失败:" + e.message);
			});
		}
		function logout(auth){
			if(auth.authResult){
				auth.logout(function(e){
					//$.toast("退出登录成功");
				}, function(e){
					//$.toast("退出登录失败：" + e.message);
				});
			}
		}
	};
	
}(mui, window.oauthLogin = {}));
