(function($,avalon){
	if(window.location.href.indexOf("home_search.html")>=0){
		var vm = interfaceList.createVm("homeSearchCtrl",{
			homeSearchList : [],
			key : "",
			wifiState : true,
			offlineNums : 0
		});
		$.plusReady(function(){
			var wifistate = interfaceList.drageWifi();
			//如果没有网络，则读取文件数据
			if(wifistate==false){
				vm.wifiState = false;
				document.getElementById("errorMsg") ? document.getElementById("errorMsg").innerText='网络异常,您可以通过 "搜索" 按钮搜索您的离线词条' : "";
				
				//读取文件数据
				if(interfaceList.isLogin()==false) return;
			}else{
				interfaceList.getAjax("/system/hot/search/listHotSearch.htm",{},"POST",function(msg){
					vm.homeSearchList = msg.data;
				});
			}
		});
		//默认初始化词条内容
		var entryVM = interfaceList.createAjaxVM("entryListCtrl",{
			path : "/cms/lemma/list.htm",
			configEntry : {
				entryList : [],
				loadingState : 0,
				pageState : true
			},
			loadParams : {
				key : vm.key
			},
			loadCallback :function(data){
				entryVM.configEntry.entryList.pushArray(data);
				interfaceList.closePageLoading();
			},
			searchCallback : function(data){
				entryVM.configEntry.entryList = data;
				interfaceList.closePageLoading();
			},
			delayLoaded : true,
			searchResult : true,
			pageState : true
		});
		
		//默认初始化案例内容
		var caseVM = interfaceList.createAjaxVM("caseSearchListCtrl",{
			path : "/case/listByKey.htm",
			configCase : {
				caseList : [],
				loadingState : 0
			},
			loadParams : {
				key : 1
			},
			loadCallback : function(data){
				caseVM.configCase.caseList.pushArray(data);
			},
			searchCallback : function(data){
				caseVM.configCase.caseList = data;
			},
			delayLoaded : true,
			searchResult : true,
			pageState : true
		});
		
		//默认初始化专家内容
		var professorVM = interfaceList.createAjaxVM("professorListCtrl",{
			path : "/member/expert/listByKey.htm",
			configProfessor : {
				professorList : [],
				loadingState : 0
			},
			loadParams : {
				key : 1
			},
			loadCallback : function(data){
				professorVM.configProfessor.professorList.pushArray(data);
			},
			searchCallback : function(data){
				professorVM.configProfessor.professorList = data;
			},
			delayLoaded : true,
			searchResult : true,
			pageState : true
		});
		
		//默认初始化法律内容
		var lowerVM = interfaceList.createAjaxVM("lowerCtrl",{
			path : "/cms/legislation/list.htm",
			configLaw : {
				lowerList : [],
				loadingState : 0
			},
			loadParams : {
				key : 1
			},
			loadCallback : function(data){
				lowerVM.configLaw.lowerList.pushArray(data);
			},
			searchCallback : function(data){
				lowerVM.configLaw.lowerList = data;
			},
			delayLoaded : true,
			searchResult : true,
			pageState : true
		});
		
		
		$('[target="homeHotSearch"]').off("tap","a").on("tap","a",function(e){
			e.stopPropagation();
			e.preventDefault();
			var value = this.innerText;
			document.getElementById("searchKeys").value = value,document.getElementById("searchKeys").focus();
			triigerEvent(value);
		});
		
		document.getElementById("searchBtn").addEventListener("tap",function(e){
			e.stopPropagation();
			e.preventDefault();
			var value = document.getElementById("searchKeys").value;
			triigerEvent(value);
		},false);
		
		$("#lower").off("tap",".lawerRows").on("tap",".lawerRows",function(e){
			e.stopPropagation();
			e.preventDefault();
			var lowerId = this.getAttribute("lowerId"),
				index = this.getAttribute("index");
			interfaceList.openWebview("/pages/home/lawDetail.html","lawDetail.html",{
				extras : {
					params : {
						lawId : lowerId ,
						lawInstance : lowerVM.configLaw.lowerList[index]
					}
				}
			},false,false);
		});
	};
	
	//案例浏览次数修改回调
	window.addEventListener("caseReadNumber",function(e){
		var id = e.detail.CaseId,
			agreeNumber = e.detail.agreeNumber,
			readerNumber = e.detail.readNumber;
		if(readerNumber!=null){
			$('[readerNumber="'+id+'"]')[0].innerText = readerNumber;
		};
		if(agreeNumber!=null){
			$('[agreeNumber="'+id+'"]')[0].innerText = agreeNumber;
		};
	},false);
	
	function getEntryFromFile(callback,nums){
		var memberId = interfaceList.getCache("memberId"),
			entryUserList = interfaceList.getCache(memberId) || {},
			downloadEntryList = entryUserList["entryList"] ? JSON.parse(entryUserList["entryList"]) : entryUserList["entryList"];
			
			entryVM.configEntry.cacheEntryList = newData.data;
			callback ? callback() : "";
			
		if(entryUserList.indexOf(memberId)>=0){
			//读取词条离线缓存内容
			plus.io.resolveLocalFileSystemURL("_downloads/download/decompress/entryList/"+memberId+".json",function(entry){
				entry.file(function(files){
					var reader = new plus.io.FileReader();
					reader.onloadend=function(e){
						var responseData = e.target.result || "{data:[]}",
							newData = JSON.parse(responseData);
						
					};
					reader.readAsText(files,"gbk");
				})
			},function(){
				interfaceList.toast("读取文件失败!");
			});
		};
	};
	
	function loadingEntry(value){
		//加载离线词条
		var data = entryVM.configEntry.cacheEntryList || [],
			newData = [];
		for(var i=0;i<data.length;i++){
			if((data[i]["name"] ? data[i]["name"].indexOf(value)>=0 : false) || (data[i]["appContent"] ? data[i]["appContent"].indexOf(value)>=0 : false)){
				newData.push(data[i]);
			}
		}
		entryVM.configEntry.entryList = newData;
	};
	
	function getLawFromFile(callback,nums){
		var memberId = interfaceList.getCache("memberId"),
			lawList = plus.storage.getItem(PUSLIC_MESSAGE.cacheLaw) || "";
		if(lawList.indexOf(memberId)>=0){
			//读取法律法规离线缓存内容
			plus.io.resolveLocalFileSystemURL("_downloads/download/decompress/lawList/"+memberId+".json",function(entry){
				entry.file(function(files){
					var reader = new plus.io.FileReader();
					reader.onloadend=function(e){
						var responseData = e.target.result || "{data:[]}",
							newData = JSON.parse(responseData);
						lowerVM.configLaw.lowerList = newData.data;
						plus.nativeUI.closeWaiting();
					};
					reader.readAsText(files,"gbk");
				})
			},function(){
				interfaceList.toast("读取文件失败!");
			});
		}
	};
	
	function loadingLaw(value){
		//加载离线法律法规
		var lawData = lowerVM.configLaw.lowerList || [],
			lawNewData = [];
		for(var i=0;i<lawData.length;i++){
			if((lawData[i]["name"] ? lawData[i]["name"].indexOf(value)>=0 : false) || (lawData[i]["summary"] ? lawData[i]["summary"].indexOf(value)>=0 : false)){
				lawNewData.push(lawData[i]);
			}
		}
		lowerVM.configLaw.lowerList = lawNewData;
	}
	
	function triigerEvent(value){
		document.getElementById("homeHotSeach").style.display="none";
		document.getElementById("homeSearchList").style.display="block";
		if(interfaceList.drageWifi()==false){
			entryVM.configEntry.pageState = false;
			plus.nativeUI.showWaiting("正在加载内容，请稍候...");
			var memberId = interfaceList.getCache("memberId"),
				userCacheData = interfaceList.getCache(memberId) || {};
				
			//加载离线词条
			if(!entryVM.configEntry.cacheEntryList){
				var downloadEntryList = userCacheData["entryList"] ? JSON.parse(userCacheData["entryList"]) : userCacheData["entryList"];
				entryVM.configEntry.cacheEntryList = downloadEntryList
			};
			var data = entryVM.configEntry.cacheEntryList || [],
				newData = [];
			for(var i=0;i<data.length;i++){
				if((data[i]["name"] ? data[i]["name"].indexOf(value)>=0 : false) || (data[i]["appContent"] ? data[i]["appContent"].indexOf(value)>=0 : false)){
					newData.push(data[i]);
				}
			};
			entryVM.configEntry.entryList = newData;
		
			//加载离线法律规范
			if(lowerVM.configLaw.lowerList.length==0){
				var downloadLawList = userCacheData["lawList"] ? JSON.parse(userCacheData["lawList"]) : userCacheData["lawList"];
				lowerVM.configLaw.lowerList = downloadLawList;
			};
			var lawData = lowerVM.configLaw.lowerList || [],
				lawNewData = [];
			for(var i=0;i<lawData.length;i++){
				if((lawData[i]["name"] ? lawData[i]["name"].indexOf(value)>=0 : false) || (lawData[i]["summary"] ? lawData[i]["summary"].indexOf(value)>=0 : false)){
					lawNewData.push(lawData[i]);
				}
			}
			lowerVM.configLaw.lowerList = lawNewData;
			plus.nativeUI.closeWaiting();
		}else{
			entryVM.loadParams.key = value,entryVM.delayLoaded= typeof entryVM.delayLoaded == "boolean" ? 1 : entryVM.delayLoaded+1;
			caseVM.loadParams.key = value,caseVM.delayLoaded= typeof caseVM.delayLoaded == "boolean" ? 1 : caseVM.delayLoaded+1;
			professorVM.loadParams.key = value,professorVM.delayLoaded= typeof professorVM.delayLoaded == "boolean" ? 1 : professorVM.delayLoaded+1;
			lowerVM.loadParams.key= value,lowerVM.delayLoaded= typeof lowerVM.delayLoaded == "boolean" ? 1 : lowerVM.delayLoaded+1;
		}
	};
	
	avalon.ready(function(){
		avalon.component("area_entry",{
			template : 	'<ul class="service_list">'+
							'<li ms-for="(index,entry) in @entryList" class="entrylist" ms-attr="{entryId : entry.id,index : index}">'+
							'<div class="service_descrit pd0">'+
								'<h6 ms-html="entry.name | entryFileter"></h6>'+
								'<p ms-html="entry.summary | entryFileter"></p>'+
							'</div>'+
						'</li></ul>',
			defaults : {
				entryList : [],
				onReady : function(){
					var dom = this.$element,
						_this = this;
					$(dom).off("tap",".entrylist").on("tap",".entrylist",function(e){
						e.stopPropagation();
						e.preventDefault();
						var entryId = this.getAttribute("entryId"),
							index = this.getAttribute("index");
						interfaceList.openWebview("/pages/home/entryDetail.html","entryDetail.html",{
							extras : {
								params : {
									entryId : entryId,
									entryInstance : _this.entryList[index]
								}
							}
						},false,false);
					});
				}
			},
			soleSlot: 'content'
		});
		
		avalon.component("area_case",{
			template : '<ul class="home_case_detail clearfix">'+
							'<li class="clearfix caseLists" ms-for="caseObj in @caseList" >'+
								'<span style="display:none;" class="caseListHiddenValue" ms-text="caseObj.id"></span>'+
								'<div>'+
									'<img :attr="{src:caseObj.imageUrl}" />'+
									/*'<label class="labels news">最新</label>'+*/
								'</div>'+
								'<p class="mt5 ellipsis" ms-text="caseObj.name"></p>'+
								'<div>'+
									'<p class="floatL home_case_count">'+
										'<i class="iconfont icon-iconfontliulan"></i>'+
										'<span ms-text="caseObj.readerNumber || 0" ms-attr="{readerNumber : caseObj.id}"></span>'+
									'</p>'+
									'<p class="floatL ml20 home_case_count">'+
										'<i class="iconfont icon-iconfontcollect font14"></i>'+
										'<span ms-text="caseObj.agreeNumber || 0" ms-attr="{agreeNumber : caseObj.id}"></span>'+
									'</p>'+
								'</div>'+
							'</li>'+
						'</ul>',
			defaults :{
				caseList : [],
				onReady : function(){
					var dom = this.$element;
					$(dom).off("tap",".caseLists").on("tap",".caseLists",function(e){
						e.stopPropagation();
						e.preventDefault();
						var caseId = this.querySelector(".caseListHiddenValue").innerText;
						interfaceList.openWebview("/pages/case/case_detail.html","caseDetails",{
							extras : {
								params : {
									caseId : caseId
								}
							}
						})
					});
				}
			},
			soleSlot: 'content'
		});
		
		avalon.component("case_list",{
			template : 	'<div><p style="color:red;margin-top:50px;color:#333;" ms-if="@caseList.length<=0" class="messageNone">暂无相关案例信息</p><ul class="caseListByCategory clearfix" ms-if="@caseList.length>0">'+
							'<li class="clearfix caseLists" ms-for="caseObj in @caseList" >'+
								'<span style="display:none;" class="caseListHiddenValue" ms-text="caseObj.id"></span>'+
								'<div class="floatL">'+
									'<img :attr="{src:caseObj.imageUrl}" class="caseListimg" />'+
								'</div>'+
								'<div class="floatL caseListContent">'+
									'<h2 class="ellipsis"  ms-text="caseObj.name" style="color:#101010;"></h2>'+
									'<p class="mt5 ellipsis" ms-html="caseObj.description || "暂无描述""></p>'+
									'<div>'+
										'<p class="floatL home_case_count">'+
											'<i class="iconfont icon-iconfontliulan"></i>'+
											'<span ms-text="caseObj.readerNumber || 0" ms-attr="{readerNumber : caseObj.id}"></span>'+
										'</p>'+
										'<p class="floatL ml20 home_case_count">'+
											'<i class="iconfont icon-iconfontcollect font14"></i>'+
											'<span ms-text="caseObj.agreeNumber || 0" ms-attr="{agreeNumber : caseObj.id}"></span>'+
										'</p>'+
									'</div></div>'+
							'</li>'+
						'</ul></div>',
			defaults :{
				caseList : [],
				onReady : function(){
					var dom = this.$element;
					$(dom).off("tap",".caseLists").on("tap",".caseLists",function(e){
						e.stopPropagation();
						e.preventDefault();
						var caseId = this.querySelector(".caseListHiddenValue").innerText;
						interfaceList.openWebview("/pages/case/case_detail.html","caseDetails",{
							extras : {
								params : {
									caseId : caseId
								}
							}
						},false,true);
					});
				}
			},
			soleSlot: 'content'
		});
		
		avalon.component("area_professor",{
			template : '<div><p ms-if="@professorList.length<=0" class="messageNone">暂无相关专家信息</p>'+
						'<ul class="proLists" ms-if="@professorList" ms-if="@professorList.length>0">'+
							'<li id="professorDetails" class="professors" ms-for="professors in @professorList">'+
								'<span style="display:none;" class="professorHiddenValue" ms-text="professors.id"></span>'+
								'<div class="pro_img proImgStyle1" style="border-radius:50%;overflow:hidden;object-fit: cover;">'+
									'<img ms-attr="{src : professors.headerUrl}" />'+
								'</div>'+
								'<div class="flexbox pl20">'+
									'<h2>{{professors.nickName}}<i class="iconfont icon-zhuanjia mui-color_yellowDan"></i></h2>'+
									'<p class="ellipsis" ms-text="professors.userTagString"></p>'+
									'<p class="ellipsis" ms-text="professors.description"></p>'+
								'</div>'+
							'</li>'+
						'</ul></div>',
			defaults : {
				professorList : [],
				onReady : function(){
					var dom = this.$element;
					$(dom).off("tap",".professors").on("tap",".professors",function(e){
						e.stopPropagation();
						e.preventDefault();
						var id = this.querySelector(".professorHiddenValue").innerText;
						interfaceList.openWebview("/pages/professor/professor_detail.html","professor_detail.html",{
							extras : {
								params : {
									professorId : id
								}
							}
						},false,true);
					});
				}
			},
			soleSlot: 'content'
		});
		
		avalon.component("area_server",{
			template : '<ul class="service_list">'+
							'<li ms-for="servers in @serverList" class="toServerDetail" ms-attr="{id : servers.id}">'+
								'<img ms-attr="{src : servers.firstImage}" />'+
								'<div class="service_descrit">'+
									'<h6 ms-text="servers.name"></h6>'+
									'<p ms-text="servers.summary" class="mt5"></p>'+
								'</div>'+
							'</li>'+
						'</ul>',
			defaults : {
				serverList : []
			},
			soleSlot: 'content'
		});
		
		avalon.component("area_bigEvent",{
			template : '<ul class="my_userLists professors backWhite">'+
							'<li ms-for="eventBig in @eventList" class="eventLists" ms-if="@eventList.length<=0"><p>暂时没有大事件</p></li>'+
							'<li ms-for="eventBig in @eventList" class="eventLists" ms-if="@eventList.length>0">'+
								'<div class="flexBox">'+
									'<p class="mui_color_gray" ms-text="eventBig.createDate"></p>'+
									'<a class="mui_color_blue" ms-text="eventBig.description"></a>'+
								'</div>'+
								'<div class="my_userEdit" ms-if="@eventState"><i class="mui-icon mui-icon-arrowright mt10"></i></div>'+
							'</li>'+
						'</ul>',
			defaults : {
				eventList : [],
				eventState : false,
				onReady : function(){
					var dom = this.$element;
					if(this.eventState==true){
						dom.off("tap",".eventLists").on("tap",".eventLists",function(e){
							e.stopPropagation();
							e.preventDefault();
							
							
						});
					}
				}
			},
			soleSlot: 'content'
		});
		
		avalon.component("area_company",{
			template : '<div><p ms-if="@companyList.length<=0 && @showNone==false" class="messageNone">暂无相关单位信息</p><ul ms-if="@companyList.length>0" class="proLists">'+
							'<li ms-for="companys in @companyList" class="companyList" ms-attr="{name:companys.name}">'+
								'<span ms-text="companys.id" class="supplierId" style="display:none"></span>'+
								'<div class="pro_img proImgStyle1">'+
									'<img ms-attr="{src : companys.logoUrl==null || companys.logoUrl=="" ? "../../imgs/system/default.png" : companys.logoUrl}" />'+
								'</div>'+
								'<div class="flexbox pl20">'+
									'<h2 class="ellipsis" ms-text="companys.name"></h2>'+
									'<p class="ellipsis" ms-text="companys.description"></p>'+
								'</div>'+
								'<a ms-if="companys.isApply==true" style="padding-left:10px;color:#5bbde9;display:block;margin-top:10px;">审核中</a>'+
								'<a ms-if="@hasChecked==true && companys.isApply==false" class="iconChecked"><i ms-if="@currentCheck==companys.id" class="iconfont icon-iconfonttijiaochenggong"></i></a>'+
							'</li>'+
						'</ul></div>',
			defaults : {
				companyList : [],
				hasChecked : false,
				currentCheck : "",
				currentName : "",
				showNone : false,
				onReady : function(){
					var dom = this.$element,
						_this = this;
					if(this.hasChecked==false){
						$(dom).off("tap",".companyList").on("tap",".companyList",function(e){
							e.stopPropagation();
							e.preventDefault();
							var id = this.querySelector(".supplierId").innerText;
							interfaceList.openWebview("/pages/supplier/supplier_detail.html","supplierDetail",{
								extras : {
									params : {
										supplierId : id
									}
								}
							},true);
						});
					}else{
						$(dom).off("tap",".companyList").on("tap",".companyList",function(e){
							e.stopPropagation();
							e.preventDefault();
							var id = this.querySelector(".supplierId").innerText;
							_this.currentCheck = id ,_this.currentName = this.getAttribute("name");
						});
					}
				}
			},
			soleSlot: 'content'
		});
	});
})(mui,avalon);
