(function($,doc){
	$.init({
		gestureConfig: {
			tap: true, //默认为true
			doubletap: true, //默认为false
			longtap: true, //默认为false
			swipe: true, //默认为true
			drag: true, //默认为true
			hold: true, //默认为false，不监听
			release: true //默认为false，不监听
		},
		swipeBack:true,
		beforeback:function(){
			// 设置聊天页面打开标识
			interfaceList.setCache("isOpenChat","false");
			//webim.logout(function(){});
			// 重新登录IM
			$.fire(plus.webview.getLaunchWebview(),"login");
		}
	});
	
	mui.plusReady(function(){
		// 预览图片
		mui.previewImage();
		
		// 应用从后台切换到前台
		document.addEventListener("resume",function(){
			// 是否打开过相机或者相册
			var isCemeraOrGallery = interfaceList.getCache("isCemeraOrGallery");
			if(isCemeraOrGallery == "Android"){
				return;
			}
			// 重新登录
			$.fire(plus.webview.currentWebview(),"login");
		},false);
	});
	
	//配置不输出html文件
	template.config('escape', false);
	
	// 调用外部函数
	template.helper("convertMsgtoHtml",convertMsgtoHtml);
	template.helper("formatTimeStamp",webim.Tool.formatTimeStamp);
	
	// 监听程序从后台切换到前台
	document.addEventListener( "resume", function(){
		//webim.login(defaultLoginInfo,defautListeners,defaultOptions);
		//plus.networkinfo.connec
	}, false );
	
	var MIN_SOUND_TIME = 1000,
	ui = {
		body: doc.querySelector('body'),
		footer: doc.querySelector('footer'),
		footerRight: doc.querySelector('.footer-right'),
		footerLeft: doc.querySelector('.footer-left'),
		btnMsgType: doc.querySelector('#msg-type'),
		boxMsgText: doc.querySelector('#msg-text'),
		boxMsgSound: doc.querySelector('#msg-sound'),
		btnMsgImage: doc.querySelector('#msg-image'),
		areaMsgList: doc.querySelector('#msg-list'),
		boxSoundAlert: doc.querySelector('#sound-alert'),
		h: doc.querySelector('#h'),
		content: doc.querySelector('.mui-content'),
		loadMore : doc.querySelector("#chatLoadingMore"),
		loading : doc.querySelector(".chatLoading")
	};
	
	ui.h.style.width = ui.boxMsgText.offsetWidth + 'px';
	var footerPadding = ui.footer.offsetHeight - ui.boxMsgText.offsetHeight,
	msgItemTap = function(msgItem, event) {
		var msgType = msgItem.getAttribute('msg-type');
		var msgContent = msgItem.getAttribute('msg-content')
		if (msgType == 'sound') {
			player = plus.audio.createPlayer(msgContent);
			var playState = msgItem.querySelector('.play-state');
			playState.innerText = '正在播放...';
			player.play(function() {
				playState.innerText = '点击播放';
			}, function(e) {
				playState.innerText = '点击播放';
			});
		}
	};

	// 发送消息简单消息
	ui.footerRight.addEventListener('touchstart', function(event) {
		if (ui.btnMsgType.classList.contains('mui-icon-paperplane')) {
			onSendMsg();
			event.preventDefault();
		}
	});
	
	// 加载更多聊天记录
	$(".mui-content").off("tap","#chatLoadingMore").on("tap","#chatLoadingMore",function(e){
		e.stopPropagation();
		e.preventDefault();
		var _this = this,loadingDom = doc.querySelector(".chatLoading");
		_this.style.display="none",loadingDom.style.display="block";
		
		getPrePageC2CHistoryMsgs(function(resp){
			loadingDom.style.display="none";
			var html = document.getElementById("msg-list").innerHTML;
			html = template("msg-template",resp) + html;
			document.getElementById("msg-list").innerHTML = html;
		});
	});
	
	//监听input 输入事件
	ui.boxMsgText.addEventListener('input', function(event) {
		ui.btnMsgType.classList[ui.boxMsgText.value == '' ? 'remove' : 'add']('mui-icon-paperplane');
		ui.btnMsgType.setAttribute("for", ui.boxMsgText.value == '' ? '' : 'msg-text');
		ui.h.innerText = ui.boxMsgText.value.replace(new RegExp('\n', 'gm'), '\n-') || '-';
		ui.footer.style.height = (ui.h.offsetHeight + footerPadding) + 'px';
		ui.content.style.paddingBottom = ui.footer.style.height;
	});
	var focus = false;
	ui.boxMsgText.addEventListener('tap', function(event) {
		mui.scrollTo(document.body.scrollHeight,1);
		ui.boxMsgText.focus();
		setTimeout(function() {
			ui.boxMsgText.focus();
		}, 0);
		focus = true;
		setTimeout(function () {
			focus = false;
		},1000);
		event.detail.gesture.preventDefault();
	}, false);

	//解决长按“发送”按钮，导致键盘关闭的问题；
	ui.footerRight.addEventListener('touchmove', function(event) {
		if (ui.btnMsgType.classList.contains('mui-icon-paperplane')) {
			event.preventDefault();
		}
	});
	
	ui.body.addEventListener('drag', function(event) {
		//console.log('drag');
		if (Math.abs(event.detail.deltaY) > 50) {
			if (!recordCancel) {
				recordCancel = true;
				if (!audio_tips.classList.contains("cancel")) {
					audio_tips.classList.add("cancel");
				}
				audio_tips.innerHTML = "松开手指，取消发送";
			}
		} else {
			if (recordCancel) {
				recordCancel = false;
				if (audio_tips.classList.contains("cancel")) {
					audio_tips.classList.remove("cancel");
				}
				audio_tips.innerHTML = "手指上划，取消发送";
			}
		}
	}, false);
	
	//点击发送后渲染页面
	ui.footerRight.addEventListener('release', function(event) {
		if (ui.btnMsgType.classList.contains('mui-icon-paperplane')) {
			ui.boxMsgText.focus();
			setTimeout(function() {
				ui.boxMsgText.focus();
			}, 150);
			event.detail.gesture.preventDefault();
		} else if (ui.btnMsgType.classList.contains('mui-icon-mic')) {
			ui.btnMsgType.classList.add('mui-icon-compose');
			ui.btnMsgType.classList.remove('mui-icon-mic');
			ui.boxMsgText.style.display = 'none';
			ui.boxMsgSound.style.display = 'block';
			ui.boxMsgText.blur();
			document.body.focus();
		} else if (ui.btnMsgType.classList.contains('mui-icon-compose')) {
			ui.btnMsgType.classList.add('mui-icon-mic');
			ui.btnMsgType.classList.remove('mui-icon-compose');
			ui.boxMsgSound.style.display = 'none';
			ui.boxMsgText.style.display = 'block';
			//--
			//showKeyboard();
			ui.boxMsgText.focus();
			setTimeout(function() {
				ui.boxMsgText.focus();
			}, 150);
		}
	}, false);
	
	//长按开始录音监听
	var recordCancel = false;
	var recorder = null;
	var audio_tips = document.getElementById("audio_tips");
	var startTimestamp = null;
	var stopTimestamp = null;
	var stopTimer = null;
	ui.boxMsgSound.addEventListener("touchstart", function(e) {
		//console.log("start....");
		e.preventDefault();
	});
	
	// 发送语音消息
	ui.boxMsgSound.addEventListener('hold', function(event) {
		recordCancel = false;
		if(stopTimer)clearTimeout(stopTimer);
		audio_tips.innerHTML = "手指上划，取消发送";
		ui.boxSoundAlert.classList.remove('rprogress-sigh');
		setSoundAlertVisable(true);
		recorder = plus.audio.getRecorder();
		if (recorder == null) {
			plus.nativeUI.toast("不能获取录音对象");
			return;
		}
		startTimestamp = (new Date()).getTime();
		recorder.record({
			filename: "_doc/audio/"
		}, function(path) {
			if (recordCancel) return;
			onSendSoundMsg(path);
		}, function(e) {
			plus.nativeUI.toast("录音时出现异常: " + e.message);
		});
	}, false);
	
	//释放录音监听
	ui.boxMsgSound.addEventListener('release', function(event) {
		//alert("cancel")
		//console.log('release');
		if (audio_tips.classList.contains("cancel")) {
			audio_tips.classList.remove("cancel");
			audio_tips.innerHTML = "手指上划，取消发送";
		}
		//
		stopTimestamp = (new Date()).getTime();
		if (stopTimestamp - startTimestamp < MIN_SOUND_TIME) {
			audio_tips.innerHTML = "录音时间太短";
			ui.boxSoundAlert.classList.add('rprogress-sigh');
			recordCancel = true;
			stopTimer=setTimeout(function(){
				setSoundAlertVisable(false);
			},800);
		}else{
			setSoundAlertVisable(false);
		}
		recorder.stop();
	}, false);
	
	var setSoundAlertVisable=function(show){
		if(show){
			ui.boxSoundAlert.style.display = 'block';
			ui.boxSoundAlert.style.opacity = 1;
		}else{
			ui.boxSoundAlert.style.opacity = 0;
			//fadeOut 完成再真正隐藏
			setTimeout(function(){
				ui.boxSoundAlert.style.display = 'none';
			},200);
		}
	};
	
	//发送图片选择
	ui.footerLeft.addEventListener('tap', function(event) {
		var btnArray = [{
			title: "拍照"
		}, {
			title: "从相册选择"
		}];
		plus.nativeUI.actionSheet({
			cancel: "取消",
			buttons: btnArray
		}, function(e) {
			// 存放打开相机或者相册机型
			interfaceList.setCache("isCemeraOrGallery",plus.os.name);
			var index = e.index;
			switch (index) {
				case 0:
					break;
				case 1:
					var cmr = plus.camera.getCamera();
					cmr.captureImage(function(path) {
						sendPic(path);
					}, function(err) {});
					break;
				case 2:
					plus.gallery.pick(function(path) {
						sendPic(path);
					}, function(err) {}, {filter:"image",multiple:true,maximum:3,onmaxed:function(){
						mui.toast("最多只能选择3张图片");
					}});
					break;
			}
		});
	}, false);
})(mui,document);