(function($){
	var uploadPlugin = {},
		basePath = "http://app.myzczk.com",
		UPLOADER_URL = basePath+"/system/upload/upload.htm",
		DOWNLOAD_URL = basePath+"/cloud/file/download.htm",
		DOWNLOADFolder_URL = basePath+"/cloud/file/downloadByDirIds.htm",
		DOWNLOADENTRY_URL = basePath+"/cms/lemma/download.htm",
		DOWNLOADLAW_URL = basePath+"/cms/legislation/download.htm";
	$.plusReady(function(){
		uploadPlugin.getSystemPath = function(callback,direName){
			direName = direName || "uploader";
			plus.io.resolveLocalFileSystemURL("_downloads/",function(entry){
				console.log("获取当前项目系统相对路径成功！");
				entry.getDirectory(direName,{
					create : true
				},function(directEntry){
					console.log("打开或者创建"+direName+"文件夹成功！");
					callback ? callback(directEntry) : "";
				},function(e){
					console.log("打开或者创建"+direName+"文件夹失败！"+e.getMessage());
				});
			},function(err){
				console.log("获取当前项目系统相对路径错误!");
			});
		}
		
		uploadPlugin.compressImg = function(pathList,callback){
			uploadPlugin.getSystemPath(function(entry){
				for(var i=0;i<pathList.length;i++){
					var fileName = pathList[i].substring(pathList[i].lastIndexOf("/")+1),
						dst = entry.fullPath + "copy_"+fileName;
					console.log(dst);
					plus.zip.compressImage({
						src : pathList[i],
						dst : dst,
						overwrite : true,
						format : "jpg",
						quality : 100
					},function(event){
						/*console.log("压缩转换后图片的大小:"+event.size);
						console.log("压缩转换后的图片url路径:"+event.target);
						console.log("压缩转换后图片的实际宽度:"+event.width);
						console.log("压缩转换后图片的实际高度:"+event.height);*/
						
						callback ? callback(event,entry) : "";
					},function(e){
						console.log("图片压缩失败！"+e.message);
					});
				}
			});
		};
		
		uploadPlugin.createUploadTask=function(pathList,uploadingCallback,uploadedCallback){
			console.log("comming...")
			if(typeof pathList=="string"){
				pathList = [pathList];
			};
			var task = plus.uploader.createUpload(UPLOADER_URL,{
				method: "POST",
				//timeout : 3000,
				blocksize: 0,
				priority: 10,
			},function(uploader, status){
				if(status!=200){
					alert("文件上传失败!");
					uploadedCallback ? uploadedCallback("error") : "";
				}else{
					uploadedCallback ? uploadedCallback(pathList,uploader,uploader.responseText) : "";
				};
				
				//删除文件内容
				uploadSystemFile.removeRecursively(function(){
					/*console.log("删除压缩文件成功！")*/
				},function(){
					/*console.log("删除压缩文件失败！！");*/
				})
			}),
			uploadCount=0,
			uploadSystemFile = null;
			uploadPlugin.compressImg(pathList,function(event,entry){
				uploadSystemFile = entry;
				uploadCount++;
				task.addFile(event.target, {
					key: event.target
				});
				if(uploadCount==pathList.length){
					/*console.log("开始下载...");*/
					task.start();
				}
			});
			
			task.addEventListener("statechanged",function(upload){
				var progrss = Math.round(upload.uploadedSize/upload.totalSize*100);
				uploadingCallback ? uploadingCallback(progrss=="NaN" ? 0 : progrss) : "";
			},false);
		};
		
		// 上传文件
		uploadPlugin.upload = function(url,pathList,uploadingCallback,uploadedCallback){
			if(typeof pathList=="string"){
				pathList = [pathList];
			};
			var task = plus.uploader.createUpload(apiUrl+url,{
				method: "POST",
				//timeout : 3000,
				blocksize: 0,
				priority: 10,
			},function(uploader, status){
				if(status!=200){
					alert("文件上传失败!");
					uploadedCallback ? uploadedCallback("error") : "";
				}else{
					uploadedCallback ? uploadedCallback(uploader) : "";
				};
			});
			// 添加文件
			for (var i = 0; i<pathList.length; i++) {
				task.addFile(pathList[i],{"key":pathList[i]});
			}
			// 开始上传
			task.start();
		};
		
		uploadPlugin.getPictureFromSystem=function(multiple,maxNum,loadingCallback,loadedCallback,state){
			plus.gallery.pick(function(path){
				var path = multiple ? path.files : path;
				if(state && state==true){
					uploadPlugin.createUploadTask(path,loadingCallback,loadedCallback);
				}else{
					loadedCallback(path);
				}
			},function(err){
				plus.nativeUI.closeWaiting();
				/*console.log("错误编码:" + err.code + "\n错误描述信息:" + err.message);*/
			},{
				filter: "image",
				maximum: maxNum,
				multiple: multiple ? multiple : false
			})
		};
		
		uploadPlugin.getPictureFromCamera=function(loadingCallback,loadedCallback,state){
			var camera = plus.camera.getCamera(1),
				res = camera.supportedVideoResolutions[0],
				fmt = camera.supportedVideoFormats[0];
			uploadPlugin.getSystemPath(function(entry){
				camera.captureImage(function(path){
					/*console.log("照片文件路径："+path);*/
					var newPath = entry.fullPath+(path.substring(path.lastIndexOf("/")+1));
					/*console.log("新路径："+newPath);*/
					if(state && state==true){
						uploadPlugin.createUploadTask(newPath,loadingCallback,loadedCallback);
					}else{
						loadedCallback(newPath);
					}
				},function(err){
					plus.nativeUI.closeWaiting();
					/*console.log("拍照出现异常!");*/
				},{
					filename : entry.fullPath,
					resolution : res,
					format : fmt
				});
			});
		};
		
		uploadPlugin.downloadFromServer=function(obj,callbacking,callbacked,extras,loadCallback){
			if(interfaceList.isLogin()==false){
				interfaceList.toast("请先登录再下载文件!");
				return;
			};
			var path;
			if(obj.type=="file"){
				path = DOWNLOAD_URL+"?id="+obj.id+"&token="+interfaceList.getCache("token");
			}else if(obj.type=="entryList"){
				path = DOWNLOADENTRY_URL +"?token="+interfaceList.getCache("token");
			}else if(obj.type=="lawList"){
				path = DOWNLOADLAW_URL +"?token="+interfaceList.getCache("token");
			}else{
				path = DOWNLOADFolder_URL+"?id="+obj.id+"&token="+interfaceList.getCache("token");
			};
			uploadPlugin.getSystemPath(function(entry){
				var down = plus.downloader.createDownload(path,{
					method : "get",
					filename : entry.fullPath
				},function(download,status){
					console.log("文件下载成功！");
					console.log("下载文件地址:"+download.url);
					console.log("下载文件大小："+download.totalSize);
					callbacked ? callbacked(download,extras,entry,status) : "";
				});
				down.addEventListener("statechanged",function(download,status){
					/*console.log(download.downloadedSize+"\t\t"+download.totalSize);*/
					var progress = Math.round((download.downloadedSize/download.totalSize)*100);
					/*console.log("下载进度为:"+progress+"%");*/
					callbacking ? callbacking(progress,extras) : "";
				},false);
				
				down.start();
				loadCallback ? loadCallback(down) : "";
			},"download");
		};
	});
	
	uploadPlugin.uploadImgList=function(pathLists,callbacking,callbacked){
		var dom = document.getElementsByClassName("feedBackContainer")[0],
			progressDom = dom ? dom.querySelector("p") : null;
		dom ? dom.style.display="block" : "";
		uploadPlugin.createUploadTask(pathLists,function(progress){
			if(parseInt(progress)==100){
				progressDom.innerText = "正在提交表单，请稍候...";
			}else{
				progressDom.innerText = "正在上传图片:"+progress+"%";
			}
			callbacking ? callbacking(progress) : "";
		},function(pathList,uploader){
			progressDom.innerText = "正在提交表单，请稍候...";
			if(pathList=="error"){
				document.getElementById("feedBackImgUploadResult").innerText = "文件上传失败！";
				dom ? dom.style.display="none" : "";
				return;
			};
			var responseText = uploader.responseText ? eval("("+uploader.responseText+")") : {};
			if(responseText.status.toUpperCase()=="error".toUpperCase()){
				document.getElementById("feedBackImgUploadResult").innerText = "文件上传失败！";
				dom ? dom.style.display="none" : "";
				return;
			};
			document.getElementById("feedBackImgUploadResult").innerText = "";
			var responseList = JSON.stringify(responseText["data"]),
				responseData = responseList.substring(1,responseList.length-1);
			callbacked?callbacked(responseData,dom) : "";
		});
	}
	
	window.uploadPlugin = uploadPlugin;
})(mui);
